package com.sun.org.apache.xerces.internal.impl.dv.xs;

import com.sun.org.apache.xerces.internal.impl.dv.util.ByteListImpl;
import com.sun.org.apache.xerces.internal.impl.dv.InvalidDatatypeValueException;
import com.sun.org.apache.xerces.internal.impl.dv.util.HexBin;
import com.sun.org.apache.xerces.internal.impl.dv.ValidationContext;

public class HexBinaryDV extends TypeValidator
{
    public HexBinaryDV() {
    }
    
    @Override
    public short getAllowedFacets() {
        return 2079;
    }
    
    @Override
    public Object getActualValue(String content, ValidationContext context) throws InvalidDatatypeValueException {
        byte[] decoded = HexBin.decode(content);
        if (decoded == null) {
            throw new InvalidDatatypeValueException("cvc-datatype-valid.1.2.1", new Object[] { content, "hexBinary" });
        }
        return new XHex(decoded);
    }
    
    @Override
    public int getDataLength(Object value) {
        return ((HexBinaryDV.XHex)value).getLength();
    }
    
    private static final class XHex extends ByteListImpl
    {
        public XHex(byte[] data) {
            super(data);
        }
        
        @Override
        public synchronized String toString() {
            if (this.canonical == null) {
                this.canonical = HexBin.encode(this.data);
            }
            return this.canonical;
        }
        
        @Override
        public boolean equals(Object obj) {
            if (!(obj instanceof HexBinaryDV.XHex)) {
                return false;
            }
            byte[] odata = ((HexBinaryDV.XHex)obj).data;
            int len = this.data.length;
            if (len != odata.length) {
                return false;
            }
            int i = 0;
            while (i < len) {
                if (this.data[i] != odata[i]) {
                    return false;
                }
                ++i;
            }
            return true;
        }
        
        @Override
        public int hashCode() {
            int hash = 0;
            for (int i = 0; i < this.data.length; ++i) {
                hash = hash * 37 + (this.data[i] & 0xFF);
            }
            return hash;
        }
    }
}
